// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rcss3d_agent_msgs:msg/Say.idl
// generated code does not contain a copyright notice

#include "rcss3d_agent_msgs/msg/detail/say__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rcss3d_agent_msgs
const rosidl_type_hash_t *
rcss3d_agent_msgs__msg__Say__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xf6, 0x3c, 0x15, 0x99, 0x2d, 0x16, 0x1f, 0x5d,
      0xdb, 0x44, 0xd8, 0x88, 0x59, 0x99, 0xb4, 0x31,
      0x1c, 0x2e, 0x82, 0xcb, 0xf1, 0x23, 0x79, 0x7c,
      0x26, 0x6c, 0x1b, 0x3f, 0x95, 0xb6, 0x58, 0x30,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char rcss3d_agent_msgs__msg__Say__TYPE_NAME[] = "rcss3d_agent_msgs/msg/Say";

// Define type names, field names, and default values
static char rcss3d_agent_msgs__msg__Say__FIELD_NAME__message[] = "message";

static rosidl_runtime_c__type_description__Field rcss3d_agent_msgs__msg__Say__FIELDS[] = {
  {
    {rcss3d_agent_msgs__msg__Say__FIELD_NAME__message, 7, 7},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rcss3d_agent_msgs__msg__Say__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rcss3d_agent_msgs__msg__Say__TYPE_NAME, 25, 25},
      {rcss3d_agent_msgs__msg__Say__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# The say effector permits communication among agents by broadcasting messages. In order to say \n"
  "# something, the following command has to be employed.\n"
  "#\n"
  "# See restrictions: https://gitlab.com/robocup-sim/SimSpark/-/wikis/Perceptors#restrictions\n"
  "\n"
  "string message  # Up to 20 characters, which may be taken from the ASCII printing character subset\n"
  "                # [0x20, 0x7E] except the white space character and the normal brackets ( and )";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rcss3d_agent_msgs__msg__Say__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rcss3d_agent_msgs__msg__Say__TYPE_NAME, 25, 25},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 441, 441},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rcss3d_agent_msgs__msg__Say__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rcss3d_agent_msgs__msg__Say__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
