// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rcss3d_agent_msgs:msg/Vision.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/vision.hpp"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__VISION__STRUCT_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__VISION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'ball'
#include "rcss3d_agent_msgs/msg/detail/ball__struct.hpp"
// Member 'field_lines'
#include "rcss3d_agent_msgs/msg/detail/field_line__struct.hpp"
// Member 'flags'
#include "rcss3d_agent_msgs/msg/detail/flag__struct.hpp"
// Member 'goalposts'
#include "rcss3d_agent_msgs/msg/detail/goalpost__struct.hpp"
// Member 'players'
#include "rcss3d_agent_msgs/msg/detail/player__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rcss3d_agent_msgs__msg__Vision __attribute__((deprecated))
#else
# define DEPRECATED__rcss3d_agent_msgs__msg__Vision __declspec(deprecated)
#endif

namespace rcss3d_agent_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Vision_
{
  using Type = Vision_<ContainerAllocator>;

  explicit Vision_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit Vision_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _ball_type =
    rosidl_runtime_cpp::BoundedVector<rcss3d_agent_msgs::msg::Ball_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Ball_<ContainerAllocator>>>;
  _ball_type ball;
  using _field_lines_type =
    std::vector<rcss3d_agent_msgs::msg::FieldLine_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::FieldLine_<ContainerAllocator>>>;
  _field_lines_type field_lines;
  using _flags_type =
    std::vector<rcss3d_agent_msgs::msg::Flag_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Flag_<ContainerAllocator>>>;
  _flags_type flags;
  using _goalposts_type =
    std::vector<rcss3d_agent_msgs::msg::Goalpost_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Goalpost_<ContainerAllocator>>>;
  _goalposts_type goalposts;
  using _players_type =
    std::vector<rcss3d_agent_msgs::msg::Player_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Player_<ContainerAllocator>>>;
  _players_type players;

  // setters for named parameter idiom
  Type & set__ball(
    const rosidl_runtime_cpp::BoundedVector<rcss3d_agent_msgs::msg::Ball_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Ball_<ContainerAllocator>>> & _arg)
  {
    this->ball = _arg;
    return *this;
  }
  Type & set__field_lines(
    const std::vector<rcss3d_agent_msgs::msg::FieldLine_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::FieldLine_<ContainerAllocator>>> & _arg)
  {
    this->field_lines = _arg;
    return *this;
  }
  Type & set__flags(
    const std::vector<rcss3d_agent_msgs::msg::Flag_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Flag_<ContainerAllocator>>> & _arg)
  {
    this->flags = _arg;
    return *this;
  }
  Type & set__goalposts(
    const std::vector<rcss3d_agent_msgs::msg::Goalpost_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Goalpost_<ContainerAllocator>>> & _arg)
  {
    this->goalposts = _arg;
    return *this;
  }
  Type & set__players(
    const std::vector<rcss3d_agent_msgs::msg::Player_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Player_<ContainerAllocator>>> & _arg)
  {
    this->players = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rcss3d_agent_msgs::msg::Vision_<ContainerAllocator> *;
  using ConstRawPtr =
    const rcss3d_agent_msgs::msg::Vision_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Vision
    std::shared_ptr<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Vision
    std::shared_ptr<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Vision_ & other) const
  {
    if (this->ball != other.ball) {
      return false;
    }
    if (this->field_lines != other.field_lines) {
      return false;
    }
    if (this->flags != other.flags) {
      return false;
    }
    if (this->goalposts != other.goalposts) {
      return false;
    }
    if (this->players != other.players) {
      return false;
    }
    return true;
  }
  bool operator!=(const Vision_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Vision_

// alias to use template instance with default allocator
using Vision =
  rcss3d_agent_msgs::msg::Vision_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rcss3d_agent_msgs

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__VISION__STRUCT_HPP_
