// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rcss3d_agent_msgs:msg/GameState.idl
// generated code does not contain a copyright notice

#include "rcss3d_agent_msgs/msg/detail/game_state__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rcss3d_agent_msgs
const rosidl_type_hash_t *
rcss3d_agent_msgs__msg__GameState__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xed, 0x7c, 0x6e, 0xd0, 0x8d, 0xc9, 0x09, 0x19,
      0xbd, 0xd6, 0x5e, 0x75, 0x71, 0x21, 0x19, 0xd8,
      0x78, 0xb9, 0x3e, 0x94, 0xd0, 0xa2, 0x7c, 0x3a,
      0x19, 0xf5, 0xe9, 0x15, 0xfc, 0xa2, 0xf6, 0x62,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char rcss3d_agent_msgs__msg__GameState__TYPE_NAME[] = "rcss3d_agent_msgs/msg/GameState";

// Define type names, field names, and default values
static char rcss3d_agent_msgs__msg__GameState__FIELD_NAME__time[] = "time";
static char rcss3d_agent_msgs__msg__GameState__FIELD_NAME__playmode[] = "playmode";
static char rcss3d_agent_msgs__msg__GameState__FIELD_NAME__score_left[] = "score_left";
static char rcss3d_agent_msgs__msg__GameState__FIELD_NAME__score_right[] = "score_right";

static rosidl_runtime_c__type_description__Field rcss3d_agent_msgs__msg__GameState__FIELDS[] = {
  {
    {rcss3d_agent_msgs__msg__GameState__FIELD_NAME__time, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__GameState__FIELD_NAME__playmode, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__GameState__FIELD_NAME__score_left, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rcss3d_agent_msgs__msg__GameState__FIELD_NAME__score_right, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rcss3d_agent_msgs__msg__GameState__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rcss3d_agent_msgs__msg__GameState__TYPE_NAME, 31, 31},
      {rcss3d_agent_msgs__msg__GameState__FIELDS, 4, 4},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Contains several information about the actual state of the soccer game environment. The actual\n"
  "# play time and play mode are transmitted in each cycle. Play time starts from zero at kickoff and\n"
  "# is given as a floating point number in seconds, to two decimal places.\n"
  "\n"
  "float32 time  # The current play time in seconds\n"
  "string playmode  # The current play mode of the soccer game (eg. BeforeKickOff)\n"
  "int32 score_left  # The score of the left team\n"
  "int32 score_right  # The score of the right team";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rcss3d_agent_msgs__msg__GameState__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rcss3d_agent_msgs__msg__GameState__TYPE_NAME, 31, 31},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 494, 494},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rcss3d_agent_msgs__msg__GameState__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rcss3d_agent_msgs__msg__GameState__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
