// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/Vision.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/vision.h"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__VISION__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__VISION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'ball'
#include "rcss3d_agent_msgs/msg/detail/ball__struct.h"
// Member 'field_lines'
#include "rcss3d_agent_msgs/msg/detail/field_line__struct.h"
// Member 'flags'
#include "rcss3d_agent_msgs/msg/detail/flag__struct.h"
// Member 'goalposts'
#include "rcss3d_agent_msgs/msg/detail/goalpost__struct.h"
// Member 'players'
#include "rcss3d_agent_msgs/msg/detail/player__struct.h"

// constants for array fields with an upper bound
// ball
enum
{
  rcss3d_agent_msgs__msg__Vision__ball__MAX_SIZE = 1
};

/// Struct defined in msg/Vision in the package rcss3d_agent_msgs.
/**
  * Message consisting of observed vision information. 
  * Details: https://gitlab.com/robocup-sim/SimSpark/-/wikis/Perceptors#vision-perceptors
 */
typedef struct rcss3d_agent_msgs__msg__Vision
{
  rcss3d_agent_msgs__msg__Ball__Sequence ball;
  rcss3d_agent_msgs__msg__FieldLine__Sequence field_lines;
  rcss3d_agent_msgs__msg__Flag__Sequence flags;
  rcss3d_agent_msgs__msg__Goalpost__Sequence goalposts;
  rcss3d_agent_msgs__msg__Player__Sequence players;
} rcss3d_agent_msgs__msg__Vision;

// Struct for a sequence of rcss3d_agent_msgs__msg__Vision.
typedef struct rcss3d_agent_msgs__msg__Vision__Sequence
{
  rcss3d_agent_msgs__msg__Vision * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__Vision__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__VISION__STRUCT_H_
